# 9. СУЩЕСТВУЮЩИЕ РЕШЕНИЯ ПО АНАЛИЗУ СОЦИАЛЬНЫХ СЕТЕЙ 

[назад](README.md)

В связи с большой актуальностью задач, связанных с анализом данных социальных сетей, в настоящее время существует довольно много их программных решений. 

В части языков программирования и существующих библиотек можно отметить язык высокого уровня Python, имеющий существенные преимущества в части анализа больших и разнородных данных, а также пакет `networkX`. В этом пакете имеется большинство стандартных сетевых метрик, работа с различными типами связей и узлов, а также широкий функционал, простота и вычислительная скорость, присущие решениям языка Python. Отличительным преимуществом данной библиотеки является хорошая визуализация графов, в том числе большой  размерности. Помимо `networkX`, основные пакеты для сетевого анализа в Python – это `igraph` и `graphtool`. `Igraph` также есть в R (и в С/C++). В нём можно считать многие сетевые статистики и визуализировать графы. `Graphtool` обещает очень высокую скорость, особый подход к большим графам и качественную визуализацию. 

К альтернативным решениям можно отнести статистическую среду R. Для расчёта базовой описательной статистики в R можно использовать пакеты `sna`, `igraph`, `network`. Для построения статистических моделей сетей будут полезны пакеты ``statnet``, `ergm` и `RSiena`. К примеру, `RSiena`, используется для изучения динамики социальных сетей, выявления ключевых структурных механизмов формирования сетей, изучения взаимосвязи структурных и не структурных характеристик. Для изучения эволюции социальной сети все чаще используют стохастическое акторно-ориентированное моделирование (САОМ), реализованное в пакете `RSiena`. 

Помимо решений, требующих навыков владения программированием, существуют следующие аналитические инструменты: `UCINET`, `ORA`, `Pajek` и `Gephi`. Первые две программы распространяются по лицензии, а `Pajek` и `Gephi` являются свободно распространяемыми. К примеру, `Gephi` используется, прежде всего, для визуализации социальных сетей, представленных графами. 

Для более глубокого погружения в анализ данных социальных сетей рекомендуется использовать информационный ресурс Awesome Network Analysis, доступный по следующей ссылке: https://github.com/briatte/awesome-network-analysis. На данном ресурсе имеется как современная литература по данной тематике (книги, учебники, статьи), так и описания и реализация алгоритмов, а также ссылки на программные средства.

Нельзя не упоминуть Bird SQL, который компания Perplexity предоставила 15 декабря 2022 в общий доступ для поиска по Twitter http://perplexity.ai/sql. Сервис позволяет: 
- анализировать активность людей "people Sam Altman engages with the most",
- анализировать социальные графы "People followed by Jeff Bezos who don’t follow him back",
- искать наиболее популярные сообщения "most liked tweets of all time", "most liked tweets about #worldcup", "top posts about ChatGPT",
- искать экспертов в интересуемой области "top astrophysicists".

Подход использования языковых нейронный сетей для формирования запросов к базам данных многообщающий. Надеемся на появление аналогичных инструментов для других социальных сетей.

[назад](README.md)